ALTER TABLE SystemVersion CHANGE COLUMN Rev459 Rev462 bit;

ALTER TABLE `Task` CHANGE `TimeDue` `TimeDue` DATE NULL ,
CHANGE `TimeClose` `TimeClose` DATE NULL ,
CHANGE `Group` `Group` INT( 11 ) NULL;

ALTER TABLE `Task` ADD `AssignedTo` INT NULL;
ALTER TABLE `Task` ADD INDEX ( `AssignedTo` ) ;
ALTER TABLE `Task` ADD FOREIGN KEY ( `AssignedTo` ) REFERENCES `User` (`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;
ALTER TABLE `StockItem` CHANGE `SerialNumber` `SerialNumber` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_czech_ci NULL ;
UPDATE `StockItem` SET SerialNumber = NULL WHERE SerialNumber='';
ALTER TABLE `StockItem` ADD UNIQUE (`SerialNumber`);

CREATE TABLE IF NOT EXISTS `Work` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL,
  `Description` text NULL,
  `TimeStart` datetime NOT NULL,
  `Duration` float NOT NULL,
  `User` int(11) NULL,
  `Task` int(11) NULL,
  PRIMARY KEY (`Id`),
  KEY `User` (`User`),
  KEY `Task` (`Task`),
  KEY `TimeStart` (`TimeStart`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

ALTER TABLE `Work` ADD FOREIGN KEY ( `User` ) REFERENCES `User` (`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;
ALTER TABLE `Work` ADD FOREIGN KEY ( `Task` ) REFERENCES `Task` (`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;

INSERT INTO `ISMenuItem` (`Id` , `Name` , `Parent` , `Table` , `IconName`) VALUES (NULL , 'Práce', '12', 'Work', '');

ALTER TABLE `News` CHANGE `User` `User` INT( 11 ) NULL DEFAULT NULL ;